]> asedeno.scripts.mit.edu Git - git.git/blob - t/test-lib.sh
test-lib: Make the test_external_* functions TAP-aware
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset GIT_EDITOR
47 unset AUTHOR_DATE
48 unset AUTHOR_EMAIL
49 unset AUTHOR_NAME
50 unset COMMIT_AUTHOR_EMAIL
51 unset COMMIT_AUTHOR_NAME
52 unset EMAIL
53 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54 unset GIT_AUTHOR_DATE
55 GIT_AUTHOR_EMAIL=author@example.com
56 GIT_AUTHOR_NAME='A U Thor'
57 unset GIT_COMMITTER_DATE
58 GIT_COMMITTER_EMAIL=committer@example.com
59 GIT_COMMITTER_NAME='C O Mitter'
60 unset GIT_DIFF_OPTS
61 unset GIT_DIR
62 unset GIT_WORK_TREE
63 unset GIT_EXTERNAL_DIFF
64 unset GIT_INDEX_FILE
65 unset GIT_OBJECT_DIRECTORY
66 unset GIT_CEILING_DIRECTORIES
67 unset SHA1_FILE_DIRECTORIES
68 unset SHA1_FILE_DIRECTORY
69 unset GIT_NOTES_REF
70 unset GIT_NOTES_DISPLAY_REF
71 unset GIT_NOTES_REWRITE_REF
72 unset GIT_NOTES_REWRITE_MODE
73 GIT_MERGE_VERBOSITY=5
74 export GIT_MERGE_VERBOSITY
75 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
77 export EDITOR
78
79 # Protect ourselves from common misconfiguration to export
80 # CDPATH into the environment
81 unset CDPATH
82
83 unset GREP_OPTIONS
84
85 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
86         1|2|true)
87                 echo "* warning: Some tests will not work if GIT_TRACE" \
88                         "is set as to trace on STDERR ! *"
89                 echo "* warning: Please set GIT_TRACE to something" \
90                         "other than 1, 2 or true ! *"
91                 ;;
92 esac
93
94 # Convenience
95 #
96 # A regexp to match 5 and 40 hexdigits
97 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
98 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
99
100 # Each test should start with something like this, after copyright notices:
101 #
102 # test_description='Description of this test...
103 # This test checks if command xyzzy does the right thing...
104 # '
105 # . ./test-lib.sh
106 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
107                 TERM=$ORIGINAL_TERM &&
108                 export TERM &&
109                 [ -t 1 ] &&
110                 tput bold >/dev/null 2>&1 &&
111                 tput setaf 1 >/dev/null 2>&1 &&
112                 tput sgr0 >/dev/null 2>&1
113         ) &&
114         color=t
115
116 while test "$#" -ne 0
117 do
118         case "$1" in
119         -d|--d|--de|--deb|--debu|--debug)
120                 debug=t; shift ;;
121         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122                 immediate=t; shift ;;
123         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
124                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
125         -h|--h|--he|--hel|--help)
126                 help=t; shift ;;
127         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128                 verbose=t; shift ;;
129         -q|--q|--qu|--qui|--quie|--quiet)
130                 quiet=t; shift ;;
131         --with-dashes)
132                 with_dashes=t; shift ;;
133         --no-color)
134                 color=; shift ;;
135         --no-python)
136                 # noop now...
137                 shift ;;
138         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
139                 valgrind=t; verbose=t; shift ;;
140         --tee)
141                 shift ;; # was handled already
142         --root=*)
143                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
144                 shift ;;
145         *)
146                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
147         esac
148 done
149
150 if test -n "$color"; then
151         say_color () {
152                 (
153                 TERM=$ORIGINAL_TERM
154                 export TERM
155                 case "$1" in
156                         error) tput bold; tput setaf 1;; # bold red
157                         skip)  tput bold; tput setaf 2;; # bold green
158                         pass)  tput setaf 2;;            # green
159                         info)  tput setaf 3;;            # brown
160                         *) test -n "$quiet" && return;;
161                 esac
162                 shift
163                 printf "%s" "$*"
164                 tput sgr0
165                 echo
166                 )
167         }
168 else
169         say_color() {
170                 test -z "$1" && test -n "$quiet" && return
171                 shift
172                 echo "$*"
173         }
174 fi
175
176 error () {
177         say_color error "error: $*"
178         GIT_EXIT_OK=t
179         exit 1
180 }
181
182 say () {
183         say_color info "$*"
184 }
185
186 test "${test_description}" != "" ||
187 error "Test script did not set test_description."
188
189 if test "$help" = "t"
190 then
191         echo "$test_description"
192         exit 0
193 fi
194
195 exec 5>&1
196 if test "$verbose" = "t"
197 then
198         exec 4>&2 3>&1
199 else
200         exec 4>/dev/null 3>/dev/null
201 fi
202
203 test_failure=0
204 test_count=0
205 test_fixed=0
206 test_broken=0
207 test_success=0
208
209 test_external_has_tap=0
210
211 die () {
212         code=$?
213         if test -n "$GIT_EXIT_OK"
214         then
215                 exit $code
216         else
217                 echo >&5 "FATAL: Unexpected exit with code $code"
218                 exit 1
219         fi
220 }
221
222 GIT_EXIT_OK=
223 trap 'die' EXIT
224
225 # The semantics of the editor variables are that of invoking
226 # sh -c "$EDITOR \"$@\"" files ...
227 #
228 # If our trash directory contains shell metacharacters, they will be
229 # interpreted if we just set $EDITOR directly, so do a little dance with
230 # environment variables to work around this.
231 #
232 # In particular, quoting isn't enough, as the path may contain the same quote
233 # that we're using.
234 test_set_editor () {
235         FAKE_EDITOR="$1"
236         export FAKE_EDITOR
237         EDITOR='"$FAKE_EDITOR"'
238         export EDITOR
239 }
240
241 test_decode_color () {
242         sed     -e 's/.\[1m/<WHITE>/g' \
243                 -e 's/.\[31m/<RED>/g' \
244                 -e 's/.\[32m/<GREEN>/g' \
245                 -e 's/.\[33m/<YELLOW>/g' \
246                 -e 's/.\[34m/<BLUE>/g' \
247                 -e 's/.\[35m/<MAGENTA>/g' \
248                 -e 's/.\[36m/<CYAN>/g' \
249                 -e 's/.\[m/<RESET>/g'
250 }
251
252 q_to_nul () {
253         perl -pe 'y/Q/\000/'
254 }
255
256 q_to_cr () {
257         tr Q '\015'
258 }
259
260 append_cr () {
261         sed -e 's/$/Q/' | tr Q '\015'
262 }
263
264 remove_cr () {
265         tr '\015' Q | sed -e 's/Q$//'
266 }
267
268 test_tick () {
269         if test -z "${test_tick+set}"
270         then
271                 test_tick=1112911993
272         else
273                 test_tick=$(($test_tick + 60))
274         fi
275         GIT_COMMITTER_DATE="$test_tick -0700"
276         GIT_AUTHOR_DATE="$test_tick -0700"
277         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
278 }
279
280 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
281 #
282 # This will commit a file with the given contents and the given commit
283 # message.  It will also add a tag with <message> as name.
284 #
285 # Both <file> and <contents> default to <message>.
286
287 test_commit () {
288         file=${2:-"$1.t"}
289         echo "${3-$1}" > "$file" &&
290         git add "$file" &&
291         test_tick &&
292         git commit -m "$1" &&
293         git tag "$1"
294 }
295
296 # Call test_merge with the arguments "<message> <commit>", where <commit>
297 # can be a tag pointing to the commit-to-merge.
298
299 test_merge () {
300         test_tick &&
301         git merge -m "$1" "$2" &&
302         git tag "$1"
303 }
304
305 # This function helps systems where core.filemode=false is set.
306 # Use it instead of plain 'chmod +x' to set or unset the executable bit
307 # of a file in the working directory and add it to the index.
308
309 test_chmod () {
310         chmod "$@" &&
311         git update-index --add "--chmod=$@"
312 }
313
314 # Use test_set_prereq to tell that a particular prerequisite is available.
315 # The prerequisite can later be checked for in two ways:
316 #
317 # - Explicitly using test_have_prereq.
318 #
319 # - Implicitly by specifying the prerequisite tag in the calls to
320 #   test_expect_{success,failure,code}.
321 #
322 # The single parameter is the prerequisite tag (a simple word, in all
323 # capital letters by convention).
324
325 test_set_prereq () {
326         satisfied="$satisfied$1 "
327 }
328 satisfied=" "
329
330 test_have_prereq () {
331         case $satisfied in
332         *" $1 "*)
333                 : yes, have it ;;
334         *)
335                 ! : nope ;;
336         esac
337 }
338
339 # You are not expected to call test_ok_ and test_failure_ directly, use
340 # the text_expect_* functions instead.
341
342 test_ok_ () {
343         test_success=$(($test_success + 1))
344         say_color "" "ok $test_count - $@"
345 }
346
347 test_failure_ () {
348         test_failure=$(($test_failure + 1))
349         say_color error "not ok - $test_count $1"
350         shift
351         echo "$@" | sed -e 's/^/#       /'
352         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
353 }
354
355 test_known_broken_ok_ () {
356         test_fixed=$(($test_fixed+1))
357         say_color "" "ok $test_count - $@ # TODO known breakage"
358 }
359
360 test_known_broken_failure_ () {
361         test_broken=$(($test_broken+1))
362         say_color skip "not ok $test_count - $@ # TODO known breakage"
363 }
364
365 test_debug () {
366         test "$debug" = "" || eval "$1"
367 }
368
369 test_run_ () {
370         test_cleanup=:
371         eval >&3 2>&4 "$1"
372         eval_ret=$?
373         eval >&3 2>&4 "$test_cleanup"
374         return 0
375 }
376
377 test_skip () {
378         test_count=$(($test_count+1))
379         to_skip=
380         for skp in $GIT_SKIP_TESTS
381         do
382                 case $this_test.$test_count in
383                 $skp)
384                         to_skip=t
385                 esac
386         done
387         if test -z "$to_skip" && test -n "$prereq" &&
388            ! test_have_prereq "$prereq"
389         then
390                 to_skip=t
391         fi
392         case "$to_skip" in
393         t)
394                 say_color skip >&3 "skipping test: $@"
395                 say_color skip "ok $test_count: # skip $1"
396                 : true
397                 ;;
398         *)
399                 false
400                 ;;
401         esac
402 }
403
404 test_expect_failure () {
405         test "$#" = 3 && { prereq=$1; shift; } || prereq=
406         test "$#" = 2 ||
407         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
408         if ! test_skip "$@"
409         then
410                 say >&3 "checking known breakage: $2"
411                 test_run_ "$2"
412                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
413                 then
414                         test_known_broken_ok_ "$1"
415                 else
416                         test_known_broken_failure_ "$1"
417                 fi
418         fi
419         echo >&3 ""
420 }
421
422 test_expect_success () {
423         test "$#" = 3 && { prereq=$1; shift; } || prereq=
424         test "$#" = 2 ||
425         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
426         if ! test_skip "$@"
427         then
428                 say >&3 "expecting success: $2"
429                 test_run_ "$2"
430                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
431                 then
432                         test_ok_ "$1"
433                 else
434                         test_failure_ "$@"
435                 fi
436         fi
437         echo >&3 ""
438 }
439
440 test_expect_code () {
441         test "$#" = 4 && { prereq=$1; shift; } || prereq=
442         test "$#" = 3 ||
443         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
444         if ! test_skip "$@"
445         then
446                 say >&3 "expecting exit code $1: $3"
447                 test_run_ "$3"
448                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
449                 then
450                         test_ok_ "$2"
451                 else
452                         test_failure_ "$@"
453                 fi
454         fi
455         echo >&3 ""
456 }
457
458 # test_external runs external test scripts that provide continuous
459 # test output about their progress, and succeeds/fails on
460 # zero/non-zero exit code.  It outputs the test output on stdout even
461 # in non-verbose mode, and announces the external script with "# run
462 # <n>: ..." before running it.  When providing relative paths, keep in
463 # mind that all scripts run in "trash directory".
464 # Usage: test_external description command arguments...
465 # Example: test_external 'Perl API' perl ../path/to/test.pl
466 test_external () {
467         test "$#" = 4 && { prereq=$1; shift; } || prereq=
468         test "$#" = 3 ||
469         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
470         descr="$1"
471         shift
472         if ! test_skip "$descr" "$@"
473         then
474                 # Announce the script to reduce confusion about the
475                 # test output that follows.
476                 say_color "" "# run $test_count: $descr ($*)"
477                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
478                 # to be able to use them in script
479                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
480                 # Run command; redirect its stderr to &4 as in
481                 # test_run_, but keep its stdout on our stdout even in
482                 # non-verbose mode.
483                 "$@" 2>&4
484                 if [ "$?" = 0 ]
485                 then
486                         if test $test_external_has_tap -eq 0; then
487                                 test_ok_ "$descr"
488                         else
489                                 say_color "" "# test_external test $descr was ok"
490                                 test_success=$(($test_success + 1))
491                         fi
492                 else
493                         if test $test_external_has_tap -eq 0; then
494                                 test_failure_ "$descr" "$@"
495                         else
496                                 say_color error "# test_external test $descr failed: $@"
497                                 test_failure=$(($test_failure + 1))
498                         fi
499                 fi
500         fi
501 }
502
503 # Like test_external, but in addition tests that the command generated
504 # no output on stderr.
505 test_external_without_stderr () {
506         # The temporary file has no (and must have no) security
507         # implications.
508         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
509         stderr="$tmp/git-external-stderr.$$.tmp"
510         test_external "$@" 4> "$stderr"
511         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
512         descr="no stderr: $1"
513         shift
514         say >&3 "# expecting no stderr from previous command"
515         if [ ! -s "$stderr" ]; then
516                 rm "$stderr"
517
518                 if test $test_external_has_tap -eq 0; then
519                         test_ok_ "$descr"
520                 else
521                         say_color "" "# test_external_without_stderr test $descr was ok"
522                         test_success=$(($test_success + 1))
523                 fi
524         else
525                 if [ "$verbose" = t ]; then
526                         output=`echo; echo "# Stderr is:"; cat "$stderr"`
527                 else
528                         output=
529                 fi
530                 # rm first in case test_failure exits.
531                 rm "$stderr"
532                 if test $test_external_has_tap -eq 0; then
533                         test_failure_ "$descr" "$@" "$output"
534                 else
535                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
536                         test_failure=$(($test_failure + 1))
537                 fi
538         fi
539 }
540
541 # This is not among top-level (test_expect_success | test_expect_failure)
542 # but is a prefix that can be used in the test script, like:
543 #
544 #       test_expect_success 'complain and die' '
545 #           do something &&
546 #           do something else &&
547 #           test_must_fail git checkout ../outerspace
548 #       '
549 #
550 # Writing this as "! git checkout ../outerspace" is wrong, because
551 # the failure could be due to a segv.  We want a controlled failure.
552
553 test_must_fail () {
554         "$@"
555         test $? -gt 0 -a $? -le 129 -o $? -gt 192
556 }
557
558 # Similar to test_must_fail, but tolerates success, too.  This is
559 # meant to be used in contexts like:
560 #
561 #       test_expect_success 'some command works without configuration' '
562 #               test_might_fail git config --unset all.configuration &&
563 #               do something
564 #       '
565 #
566 # Writing "git config --unset all.configuration || :" would be wrong,
567 # because we want to notice if it fails due to segv.
568
569 test_might_fail () {
570         "$@"
571         test $? -ge 0 -a $? -le 129 -o $? -gt 192
572 }
573
574 # test_cmp is a helper function to compare actual and expected output.
575 # You can use it like:
576 #
577 #       test_expect_success 'foo works' '
578 #               echo expected >expected &&
579 #               foo >actual &&
580 #               test_cmp expected actual
581 #       '
582 #
583 # This could be written as either "cmp" or "diff -u", but:
584 # - cmp's output is not nearly as easy to read as diff -u
585 # - not all diff versions understand "-u"
586
587 test_cmp() {
588         $GIT_TEST_CMP "$@"
589 }
590
591 # This function can be used to schedule some commands to be run
592 # unconditionally at the end of the test to restore sanity:
593 #
594 #       test_expect_success 'test core.capslock' '
595 #               git config core.capslock true &&
596 #               test_when_finished "git config --unset core.capslock" &&
597 #               hello world
598 #       '
599 #
600 # That would be roughly equivalent to
601 #
602 #       test_expect_success 'test core.capslock' '
603 #               git config core.capslock true &&
604 #               hello world
605 #               git config --unset core.capslock
606 #       '
607 #
608 # except that the greeting and config --unset must both succeed for
609 # the test to pass.
610
611 test_when_finished () {
612         test_cleanup="{ $*
613                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
614 }
615
616 # Most tests can use the created repository, but some may need to create more.
617 # Usage: test_create_repo <directory>
618 test_create_repo () {
619         test "$#" = 1 ||
620         error "bug in the test script: not 1 parameter to test-create-repo"
621         owd=`pwd`
622         repo="$1"
623         mkdir -p "$repo"
624         cd "$repo" || error "Cannot setup test environment"
625         "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
626         error "cannot run git init -- have you built things yet?"
627         mv .git/hooks .git/hooks-disabled
628         cd "$owd"
629 }
630
631 test_done () {
632         GIT_EXIT_OK=t
633         test_results_dir="$TEST_DIRECTORY/test-results"
634         mkdir -p "$test_results_dir"
635         test_results_path="$test_results_dir/${0%.sh}-$$"
636
637         echo "total $test_count" >> $test_results_path
638         echo "success $test_success" >> $test_results_path
639         echo "fixed $test_fixed" >> $test_results_path
640         echo "broken $test_broken" >> $test_results_path
641         echo "failed $test_failure" >> $test_results_path
642         echo "" >> $test_results_path
643
644         if test "$test_fixed" != 0
645         then
646                 say_color pass "# fixed $test_fixed known breakage(s)"
647         fi
648         if test "$test_broken" != 0
649         then
650                 say_color error "# still have $test_broken known breakage(s)"
651                 msg="remaining $(($test_count-$test_broken)) test(s)"
652         else
653                 msg="$test_count test(s)"
654         fi
655         case "$test_failure" in
656         0)
657                 # Maybe print SKIP message
658                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
659
660                 if test $test_external_has_tap -eq 0; then
661                         say_color pass "# passed all $msg"
662                         say "1..$test_count$skip_all"
663                 fi
664
665                 test -d "$remove_trash" &&
666                 cd "$(dirname "$remove_trash")" &&
667                 rm -rf "$(basename "$remove_trash")"
668
669                 exit 0 ;;
670
671         *)
672                 if test $test_external_has_tap -eq 0; then
673                         say_color error "# failed $test_failure among $msg"
674                         say "1..$test_count"
675                 fi
676
677                 exit 1 ;;
678
679         esac
680 }
681
682 # Test the binaries we have just built.  The tests are kept in
683 # t/ subdirectory and are run in 'trash directory' subdirectory.
684 TEST_DIRECTORY=$(pwd)
685 if test -n "$valgrind"
686 then
687         make_symlink () {
688                 test -h "$2" &&
689                 test "$1" = "$(readlink "$2")" || {
690                         # be super paranoid
691                         if mkdir "$2".lock
692                         then
693                                 rm -f "$2" &&
694                                 ln -s "$1" "$2" &&
695                                 rm -r "$2".lock
696                         else
697                                 while test -d "$2".lock
698                                 do
699                                         say "Waiting for lock on $2."
700                                         sleep 1
701                                 done
702                         fi
703                 }
704         }
705
706         make_valgrind_symlink () {
707                 # handle only executables
708                 test -x "$1" || return
709
710                 base=$(basename "$1")
711                 symlink_target=$TEST_DIRECTORY/../$base
712                 # do not override scripts
713                 if test -x "$symlink_target" &&
714                     test ! -d "$symlink_target" &&
715                     test "#!" != "$(head -c 2 < "$symlink_target")"
716                 then
717                         symlink_target=../valgrind.sh
718                 fi
719                 case "$base" in
720                 *.sh|*.perl)
721                         symlink_target=../unprocessed-script
722                 esac
723                 # create the link, or replace it if it is out of date
724                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
725         }
726
727         # override all git executables in TEST_DIRECTORY/..
728         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
729         mkdir -p "$GIT_VALGRIND"/bin
730         for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
731         do
732                 make_valgrind_symlink $file
733         done
734         OLDIFS=$IFS
735         IFS=:
736         for path in $PATH
737         do
738                 ls "$path"/git-* 2> /dev/null |
739                 while read file
740                 do
741                         make_valgrind_symlink "$file"
742                 done
743         done
744         IFS=$OLDIFS
745         PATH=$GIT_VALGRIND/bin:$PATH
746         GIT_EXEC_PATH=$GIT_VALGRIND/bin
747         export GIT_VALGRIND
748 elif test -n "$GIT_TEST_INSTALLED" ; then
749         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
750         error "Cannot run git from $GIT_TEST_INSTALLED."
751         PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
752         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
753 else # normal case, use ../bin-wrappers only unless $with_dashes:
754         git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
755         if ! test -x "$git_bin_dir/git" ; then
756                 if test -z "$with_dashes" ; then
757                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
758                 fi
759                 with_dashes=t
760         fi
761         PATH="$git_bin_dir:$PATH"
762         GIT_EXEC_PATH=$TEST_DIRECTORY/..
763         if test -n "$with_dashes" ; then
764                 PATH="$TEST_DIRECTORY/..:$PATH"
765         fi
766 fi
767 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
768 unset GIT_CONFIG
769 GIT_CONFIG_NOSYSTEM=1
770 GIT_CONFIG_NOGLOBAL=1
771 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
772
773 . ../GIT-BUILD-OPTIONS
774
775 if test -z "$GIT_TEST_CMP"
776 then
777         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
778         then
779                 GIT_TEST_CMP="$DIFF -c"
780         else
781                 GIT_TEST_CMP="$DIFF -u"
782         fi
783 fi
784
785 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
786 export GITPERLLIB
787 test -d ../templates/blt || {
788         error "You haven't built things yet, have you?"
789 }
790
791 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
792 then
793         GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
794         export GITPYTHONLIB
795         test -d ../git_remote_helpers/build || {
796                 error "You haven't built git_remote_helpers yet, have you?"
797         }
798 fi
799
800 if ! test -x ../test-chmtime; then
801         echo >&2 'You need to build test-chmtime:'
802         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
803         exit 1
804 fi
805
806 # Test repository
807 test="trash directory.$(basename "$0" .sh)"
808 test -n "$root" && test="$root/$test"
809 case "$test" in
810 /*) TRASH_DIRECTORY="$test" ;;
811  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
812 esac
813 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
814 rm -fr "$test" || {
815         GIT_EXIT_OK=t
816         echo >&5 "FATAL: Cannot prepare test area"
817         exit 1
818 }
819
820 test_create_repo "$test"
821 # Use -P to resolve symlinks in our working directory so that the cwd
822 # in subprocesses like git equals our $PWD (for pathname comparisons).
823 cd -P "$test" || exit 1
824
825 this_test=${0##*/}
826 this_test=${this_test%%-*}
827 for skp in $GIT_SKIP_TESTS
828 do
829         to_skip=
830         for skp in $GIT_SKIP_TESTS
831         do
832                 case "$this_test" in
833                 $skp)
834                         to_skip=t
835                 esac
836         done
837         case "$to_skip" in
838         t)
839                 say_color skip >&3 "skipping test $this_test altogether"
840                 say_color skip "skip all tests in $this_test"
841                 test_done
842         esac
843 done
844
845 # Provide an implementation of the 'yes' utility
846 yes () {
847         if test $# = 0
848         then
849                 y=y
850         else
851                 y="$*"
852         fi
853
854         while echo "$y"
855         do
856                 :
857         done
858 }
859
860 # Fix some commands on Windows
861 case $(uname -s) in
862 *MINGW*)
863         # Windows has its own (incompatible) sort and find
864         sort () {
865                 /usr/bin/sort "$@"
866         }
867         find () {
868                 /usr/bin/find "$@"
869         }
870         sum () {
871                 md5sum "$@"
872         }
873         # git sees Windows-style pwd
874         pwd () {
875                 builtin pwd -W
876         }
877         # no POSIX permissions
878         # backslashes in pathspec are converted to '/'
879         # exec does not inherit the PID
880         ;;
881 *)
882         test_set_prereq POSIXPERM
883         test_set_prereq BSLASHPSPEC
884         test_set_prereq EXECKEEPSPID
885         ;;
886 esac
887
888 test -z "$NO_PERL" && test_set_prereq PERL
889 test -z "$NO_PYTHON" && test_set_prereq PYTHON
890
891 # test whether the filesystem supports symbolic links
892 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
893 rm -f y